# blineconvert.cpp File Reference

Template File. More...

`#include "blineconvert.h"`
`#include <vector>`
`#include <ETL/gaussian>`
`#include <ETL/hermite>`
`#include <ETL/clock>`
`#include <float.h>`
`#include <algorithm>`
`#include <synfig/general.h>`
`#include <cassert>`
`#include "general.h"`

## Defines

#define | EPSILON (1e-10)

## Typedefs

typedef synfigapp::BLineConverter::cpindex | cpindex

## Functions

template<class T>
void | FivePointdt (T &df, const T &f1, const T &f2, const T &f3, const T &f4, const T &f5, int bias)
template<class T>
void | ThreePointdt (T &df, const T &f1, const T &f2, const T &f3, int bias)
void | GetFirstDerivatives (const std::vector< synfig::Point > &f, unsigned int left, unsigned int right, char *out, unsigned int dfstride)
void | GetSimpleDerivatives (const std::vector< synfig::Point > &f, int left, int right, std::vector< synfig::Point > &df, int outleft, const std::vector< synfig::Real > &)
Real | CurveError (const synfig::Point *pts, unsigned int n, std::vector< synfig::Point > &work, int left, int right)
int | tessellate_curves (const std::vector< cpindex > &inds, const std::vector< Point > &f, const std::vector< synfig::Vector > &df, std::vector< Point > &work)

## Detailed Description

Template File.

$Id$

## Define Documentation

#define EPSILON (1e-10)

## Typedef Documentation

typedef synfigapp::BLineConverter::cpindex cpindex

## Function Documentation

template<class T>

void FivePointdt | ( | T & | df,
|  | const T & | f1,
|  | const T & | f2,
|  | const T & | f3,
|  | const T & | f4,
|  | const T & | f5,
|  | int | bias |
| ) |  |  | `[inline]`

Referenced by GetFirstDerivatives().

template<class T>

void ThreePointdt | ( | T & | df,
|  | const T & | f1,
|  | const T & | f2,
|  | const T & | f3,
|  | int | bias |
| ) |  |  | `[inline]`

Referenced by GetFirstDerivatives().

void GetFirstDerivatives | ( | const std::vector< synfig::Point > & | f,
|  | unsigned int | left,
|  | unsigned int | right,
|  | char * | out,
|  | unsigned int | dfstride |
| ) |  |  |

References FivePointdt(), and ThreePointdt().

Referenced by synfigapp::BLineConverter::operator()().

void GetSimpleDerivatives | ( | const std::vector< synfig::Point > & | f,
|  | int | left,
|  | int | right,
|  | std::vector< synfig::Point > & | df,
|  | int | outleft,
|  | const std::vector< synfig::Real > & |  |
| ) |  |  |

Real CurveError | ( | const synfig::Point * | pts,
|  | unsigned int | n,
|  | std::vector< synfig::Point > & | work,
|  | int | left,
|  | int | right |
| ) |  |  |

Referenced by synfigapp::BLineConverter::operator()().

int tessellate_curves | ( | const std::vector< cpindex > & | inds,
|  | const std::vector< Point > & | f,
|  | const std::vector< synfig::Vector > & | df,
|  | std::vector< Point > & | work |
| ) |  |  |

Referenced by synfigapp::BLineConverter::operator()().